Open CASCADE Technology: ShapeAnalysis_TransferParameters Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes
ShapeAnalysis_TransferParameters Class Reference

This tool is used for transferring parameters from 3d curve of the edge to pcurve and vice versa. More...

`#include <ShapeAnalysis_TransferParameters.hxx>`

Inheritance diagram for ShapeAnalysis_TransferParameters:
[legend]

## Public Member Functions
| ShapeAnalysis_TransferParameters ()
| Creates empty tool with myShift = 0 and myScale = 1. More...
| ShapeAnalysis_TransferParameters (const TopoDS_Edge &E, const TopoDS_Face &F)
| Creates a tool and initializes it with edge and face. More...
virtual void | Init (const TopoDS_Edge &E, const TopoDS_Face &F)
| Initialize a tool with edge and face. More...
void | SetMaxTolerance (const Standard_Real maxtol)
| Sets maximal tolerance to use linear recomputation of parameters. More...
virtual Handle< TColStd_HSequenceOfReal > | Perform (const Handle< TColStd_HSequenceOfReal > &Params, const Standard_Boolean To2d)
| Transfers parameters given by sequence Params from 3d curve to pcurve (if To2d is True) or back (if To2d is False) More...
virtual Standard_Real | Perform (const Standard_Real Param, const Standard_Boolean To2d)
| Transfers parameter given by sequence Params from 3d curve to pcurve (if To2d is True) or back (if To2d is False) More...
virtual void | TransferRange (TopoDS_Edge &newEdge, const Standard_Real prevPar, const Standard_Real currPar, const Standard_Boolean To2d)
| Recomputes range of curves from NewEdge. If Is2d equals True parameters are recomputed by curve2d else by curve3d. More...
virtual Standard_Boolean | IsSameRange () const
| Returns True if 3d curve of edge and pcurve are SameRange (in default implementation, if myScale == 1 and myShift == 0) More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Attributes
Standard_Real | myFirst
Standard_Real | myLast
TopoDS_Edge | myEdge
Standard_Real | myMaxTolerance

## Detailed Description

This tool is used for transferring parameters from 3d curve of the edge to pcurve and vice versa.

Default behaviour is to trsnafer parameters with help of linear transformation:

T2d = myShift + myScale * T3d where myScale = ( Last2d - First2d ) / ( Last3d - First3d ) myShift = First2d - First3d * myScale [First3d, Last3d] and [First2d, Last2d] are ranges of edge on curve and pcurve

This behaviour can be redefined in derived classes, for example, using projection.

## Constructor & Destructor Documentation

ShapeAnalysis_TransferParameters::ShapeAnalysis_TransferParameters | ( |  | ) |

Creates empty tool with myShift = 0 and myScale = 1.

ShapeAnalysis_TransferParameters::ShapeAnalysis_TransferParameters | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F
| ) |  |

Creates a tool and initializes it with edge and face.

## Member Function Documentation

virtual void ShapeAnalysis_TransferParameters::Init | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F
| ) |  |
| virtual

Initialize a tool with edge and face.

Reimplemented in ShapeAnalysis_TransferParametersProj.

virtual Standard_Boolean ShapeAnalysis_TransferParameters::IsSameRange | ( |  | ) | const
| virtual

Returns True if 3d curve of edge and pcurve are SameRange (in default implementation, if myScale == 1 and myShift == 0)

Reimplemented in ShapeAnalysis_TransferParametersProj.

virtual Handle< TColStd_HSequenceOfReal > ShapeAnalysis_TransferParameters::Perform | ( | const Handle< TColStd_HSequenceOfReal > & | Params,
|  | const Standard_Boolean | To2d
| ) |  |
| virtual

Transfers parameters given by sequence Params from 3d curve to pcurve (if To2d is True) or back (if To2d is False)

Reimplemented in ShapeAnalysis_TransferParametersProj.

virtual Standard_Real ShapeAnalysis_TransferParameters::Perform | ( | const Standard_Real | Param,
|  | const Standard_Boolean | To2d
| ) |  |
| virtual

Transfers parameter given by sequence Params from 3d curve to pcurve (if To2d is True) or back (if To2d is False)

Reimplemented in ShapeAnalysis_TransferParametersProj.

void ShapeAnalysis_TransferParameters::SetMaxTolerance | ( | const Standard_Real | maxtol | ) |

Sets maximal tolerance to use linear recomputation of parameters.

virtual void ShapeAnalysis_TransferParameters::TransferRange | ( | TopoDS_Edge & | newEdge,
|  | const Standard_Real | prevPar,
|  | const Standard_Real | currPar,
|  | const Standard_Boolean | To2d
| ) |  |
| virtual

Recomputes range of curves from NewEdge. If Is2d equals True parameters are recomputed by curve2d else by curve3d.

Reimplemented in ShapeAnalysis_TransferParametersProj.

## Field Documentation

TopoDS_Edge ShapeAnalysis_TransferParameters::myEdge
| protected

Standard_Real ShapeAnalysis_TransferParameters::myFirst
| protected

Standard_Real ShapeAnalysis_TransferParameters::myLast
| protected

Standard_Real ShapeAnalysis_TransferParameters::myMaxTolerance
| protected

The documentation for this class was generated from the following file:

- ShapeAnalysis_TransferParameters.hxx